<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	// Events
	define('TA','TA'); // New task Assigned
	define('TS','TS'); // Task status changed
	define('CO','CO'); // Task status changed
	define('AT','AT'); // New attachment
	define('TD','TD'); // Task Due Date Changed
	define('TT','TT'); // Timsesheet toggle start || stop
	define('TP','TP');
	define('TU','TU'); // Task Update

/*
	$worker	= new GearmanWorker();
	$worker->addServer();

	$worker->addFunction("newTaskEvent", "new_task_event");
	$worker->addFunction("newCommentEvent", "new_comment_event");
	$worker->addFunction("newAttachmentEvent", "new_attachment_event");
	$worker->addFunction("toggleTimesheet", "toggle_timesheet");
*/

	function ot_wrap_word($word="")
	{
		$word	= strtok($word, "\n");
		if (strlen($word) > 60)
		{
			return strtok(wordwrap($word, 60, "\n", false), "\n") . "...";
		}
		return $word;
	}

	$CI =& get_instance();

	function toggleTimesheet($data)
	{
		global $CI;

		$data = json_decode($data);

		$user_id 	= !empty($data->user_id)?$data->user_id:0;
		$entity_id 	= !empty($data->entity_id)?$data->entity_id:0;

		if (!$user_id || !$entity_id || empty($data->time_sheet_id))
			return false;
		$sql = 'SELECT if(pr.project_code !="" , pr.project_code, concat(pr.project_name," - ")) AS project , t.activity_name as name, t.is_progress FROM ot_time_sheet AS t JOIN ot_project AS pr ON t.entity_id=pr.entity_id and t.project_id = pr.project_id WHERE t.time_sheet_id='.$data->time_sheet_id.' AND t.entity_id='.$entity_id.' AND t.user_id ='.$user_id;
	
		$query = $CI->db->query($sql);
		$result	= $query->row_array();

		if (!$result) return true;
		
		$events 	= get_apps_user_list($user_id, $entity_id, array($user_id));

		if (!$events) return false;
	
		$app_events 	=	$events['app_events'];
		$user_events 	=	$events['user_events'];
	
		if (empty($app_events[TT]) || empty($user_events[TT]))
			return false;
	
		$values = $events['from_user'];
		$values['task_name'] 	= '';
		$values['cur_time'] 	= '';
		if (isset($data->cur_time)) {
			$values['task_name'] 	= $result['project'].$result['name'];
			$values['cur_time'] 	=' | '.$data->cur_time;
		}
		$followers = array($user_id);

		trigger_event($app_events[TT], $user_events[TT], $values, $followers, array(
			'time_sheet_id'	=> $data->time_sheet_id,
			'is_progress'	=> $result['is_progress']
		));
	}
	
	function newCommentEvent($data)
	{
		global $CI;

		$data = json_decode($data);

		$user_id 	= !empty($data->user_id)?$data->user_id:0;
		$entity_id 	= !empty($data->entity_id)?$data->entity_id:0;

		if (!$user_id || !$entity_id || empty($data->module_id))
			return false;

		$notify_type = array('T','P');
		if (!in_array($data->module_type,$notify_type))
		{
			return false;
		}

		$notify_data	= array();

		switch ($data->module_type)
		{
			case 'T':
				$sql = 'SELECT CONCAT(pr.project_name," - ",pt.name) AS name, GROUP_CONCAT( ptu.user_id SEPARATOR "-") AS followers,pt.project_id, pt.task_number FROM ot_project_task_users AS ptu JOIN ot_project_task AS pt ON ptu.entity_id=pt.entity_id and ptu.task_id = pt.task_id JOIN ot_project AS pr ON pt.entity_id=pr.entity_id and pt.project_id = pr.project_id WHERE pt.entity_id='.$entity_id.' AND pt.task_id ='.$data->module_id.' AND ptu.user_id!='.$user_id.' group by pt.task_id';
				$data->url = $data->task_url;
				$notify_data['task_id']	= $data->module_id;
			break;
			case 'P':
				$sql = 'SELECT pr.project_name as name, GROUP_CONCAT( pru.user_id SEPARATOR "-") AS followers ,pr.project_id FROM ot_project_users AS pru JOIN ot_project AS pr ON pru.entity_id=pr.entity_id and pru.project_id = pr.project_id WHERE pr.entity_id='.$entity_id.' AND pr.project_id ='.$data->module_id.' AND pru.user_id!='.$user_id.'  group by pr.project_id';
				$data->url = $data->project_url;
				$notify_data['project_id']	= $data->module_id;
			break;
		}

		$notify_data['comment_id']	= $data->comment_id;

		$query	= $CI->db->query($sql);
		$result	= $query->row_array();

		if (!$result || !$result['followers'])
			return true;

		$followers = explode('-',$result['followers']);

		// remove current user exists in array
		$followers = array_diff($followers,array($user_id));

		if (!$followers)
			return true;

		$events 	= get_apps_user_list($user_id, $entity_id, $followers);
		if (!$events)
			return false;

		$app_events 	=	$events['app_events'];
		$user_events 	=	$events['user_events'];
		
		if (empty($app_events[CO]) || empty($user_events[CO]))
			return false;
		
		$values = $events['from_user'];
		$values['name'] 	= $result['name'];
		$data->url.='/'.$result['project_id'];
		$values['url'] 		= substr($data->url,strpos($data->url,'://')+3);;
		$values['comment'] 	= $data->message;

		$notify_data['comment']	= ot_wrap_word($result['name']);

		if (empty($notify_data['project_id']))
		{
			$notify_data['project_id']	= $result['project_id'];
		}

		if (!empty($result['task_number']))
		{
			$notify_data['task_number']	= $result['task_number'];
		}

		trigger_event($app_events[CO], $user_events[CO],$values, $followers, $notify_data);
	}
	
	function newAttachmentEvent($data) {
		global $CI;
	
		$data = json_decode($data);

		$user_id 	= !empty($data->user_id)?$data->user_id:0;
		$entity_id 	= !empty($data->entity_id)?$data->entity_id:0;
		if (!$user_id || !$entity_id || empty($data->module_id))
			return false;
	
		$notify_type = array('T','P');
		if (!in_array($data->module_type,$notify_type))
		{
			return false;
		}

		$notify_data	= array();

		switch ($data->module_type)
		{
			case 'T':
				$sql = 'SELECT CONCAT(pr.project_name," - ",pt.name) AS name, GROUP_CONCAT( ptu.user_id SEPARATOR "-") AS followers,pt.project_id,pt.task_number FROM ot_project_task_users AS ptu JOIN ot_project_task AS pt ON ptu.entity_id=pt.entity_id and ptu.task_id = pt.task_id JOIN ot_project AS pr ON pt.entity_id=pr.entity_id and pt.project_id = pr.project_id WHERE pt.entity_id='.$entity_id.' AND pt.task_id ='.$data->module_id.' AND ptu.user_id!='.$user_id.'  group by pt.task_id';
				$data->url	= $data->task_url;
				$notify_data['task_id']	= $data->module_id;
				break;
			case 'P':
				$sql = 'SELECT pr.project_name as name, GROUP_CONCAT( pru.user_id SEPARATOR "-") AS followers,pr.project_id FROM ot_project_users AS pru JOIN ot_project AS pr ON pru.entity_id=pr.entity_id and pru.project_id = pr.project_id WHERE pr.entity_id='.$entity_id.' AND pr.project_id ='.$data->module_id.' AND pru.user_id!='.$user_id.'  group by pr.project_id';
				$data->url	= $data->project_url;
				$notify_data['project_id']	= $data->module_id;
				break;
		}

		$notify_data['attachment_id']	= $data->attachment_id;

		$query = $CI->db->query($sql);
		$result	= $query->row_array();
	
		if (!$result || !$result['followers']) return true;
		$followers = explode('-',$result['followers']);

		// remove current user exists in array
		$followers = array_diff($followers,array($user_id));
		if (!$followers) return true;
	
		$events 	= get_apps_user_list($user_id, $entity_id, $followers);
		if (!$events) return false;
	
		$app_events 	=	$events['app_events'];
		$user_events 	=	$events['user_events'];
		// $from_email 	= 	$events['from_email'];
	
		if (empty($app_events[AT]) || empty($user_events[AT]))
			return false;
		
		$values = $events['from_user'];
		$values['task_name'] 	= $result['name'];
		$data->url.='/'.$result['project_id'];
		$values['url'] 			= substr($data->url,strpos($data->url,'://')+3);;

		$notify_data['comment']	= ot_wrap_word($result['name']);

		if (empty($notify_data['project_id']))
		{
			$notify_data['project_id']	= $result['project_id'];
		}

		if (!empty($result['task_number']))
		{
			$notify_data['task_number']	= $result['task_number'];
		}

		trigger_event($app_events[AT], $user_events[AT],$values, $followers, $notify_data);
	}

	function newTaskEvent($data)
	{
		global $CI;

		$data = json_decode($data);

		$task_priorities = $CI->config->item('task_priority');

		$user_id 	= !empty($data->user_id)?$data->user_id:0;
		$entity_id 	= !empty($data->entity_id)?$data->entity_id:0;
		$data->task_url = substr($data->task_url,strpos($data->task_url,'://')+3);

		if (!$user_id || !$entity_id)
			return false;

		$old_task = array();

		if (!isset($data->task))
		{
			$task_id	= $data->task_id;
			$project_id = $data->project_id;
		}
		else
		{
			$old_task = $data->task[0];
			$task_id	= $old_task->task_id;
			$project_id = $old_task->project_id;
		}

		$notify_data	= array(
			'task_id'	=> $task_id,
			'project_id'	=> $project_id
		);

		$query = $CI->db->query('SELECT pt.*, CONCAT(pr.project_name," - ",pt.name) AS name, GROUP_CONCAT( ptu.user_id SEPARATOR "-") AS followers FROM ot_project_task_users AS ptu JOIN ot_project_task AS pt ON ptu.entity_id=pt.entity_id and ptu.task_id = pt.task_id JOIN ot_project AS pr ON pt.project_id=pr.project_id WHERE pt.entity_id='.$entity_id.' AND pt.task_id ='.$task_id.' AND ptu.user_id!='.$user_id.' AND pt.project_id =  '.$project_id.' group by pt.task_id');
		$task	= $query->row_array();

		if (!$task || !$task['followers'])
			return true;
		$all_followers = $new_followers = array();
		$new_followers = explode('-',$task['followers']);
		// $creator		= 0;
		/*foreach($tmp_followers as $asg) {
			$tmp = explode('_',$asg);
			if ($tmp[1]) {
				$creator = $tmp[0]; 
			}
			$new_followers[]=$tmp[0];
		}*/

		$all_followers = $new_followers;
		$removed_followers = $exist_followers = array();
		// followerss split
		if (isset($data->followers) && isset($data->followers[0]->users))
		{
			$old_followers 		= explode('-',$data->followers[0]->users);
			$removed_followers 	= array_values(array_diff($old_followers, $new_followers));
			$all_followers  		= array_unique(array_merge($old_followers,$new_followers));
			$exist_followers 	= array_intersect($old_followers, $new_followers);
			$new_followers 		= array_values(array_diff($all_followers, $old_followers));
		}

		// if no followers return
		if (!$all_followers)
		{
			return true;
		}
		// get app and user event list

		$events	= get_apps_user_list($user_id, $entity_id, $all_followers);

		if (!$events)
			return false;

		$app_events 	=	$events['app_events'];
		$user_events 	=	$events['user_events'];
		// $from_email 	= 	$events['from_email'];

		/*if ($creator) {
			$cr_key = array_search($creator, $new_followers);
			if ($cr_key!==false) {
				unset($new_followers[$cr_key]);
				$new_followers = array_values($new_followers);
			} 
		}*/

		if ($exist_followers && $user_id!=$task['assignee_id'] && $old_task->assignee_id!=$task['assignee_id'])
		{
			$new_followers[] = $task['assignee_id'];
		}

		if (!empty($old_task->task_status_id) && $old_task->task_status_id!=$task['task_status_id'])
		{
			$exist_followers = array_merge($exist_followers,$new_followers);
			$new_followers = array();	
		}

		$notify_data['comment']	= ot_wrap_word($task['name']);

		// trigger new task event
		if ($new_followers && !empty($app_events[TA]) && !empty($user_events[TA]))
		{
			$values = $events['from_user'];
			$values['task_name'] 		= $task['name'];
			$values['finish_date'] 		= $task['finish_date'];
			$values['task_url'] 		= $data->task_url.'/'.$task['project_id'];
			trigger_event($app_events[TA], $user_events[TA],$values, $new_followers, $notify_data);
		}

		// if followers already exists in a task	
		if ($exist_followers)
		{
			$trigger_flag	= false;

			// get all status
			$query = $CI->db->query('SELECT task_status_id, name,text_color,bg_color from ot_task_status where entity_id='.$entity_id);
			$tmp_status	= $query->result_array();

			$task_status = array();
			foreach ($tmp_status as $row)
			{
				$task_status[$row['task_status_id']]	= $row;
			}

			if (!$task['is_closed'])
			{
				// check task priority changed
				if (!empty($app_events[TP]) && !empty($user_events[TP]) && $old_task->task_priority!=$task['task_priority'])
				{
					$values = $events['from_user'];
					$values['task_name'] = $task['name'];
					$values['due_date'] 		= $task['finish_date'];
					$values['modified_date'] 	= $task['last_updated_date'];
					$values['task_url'] 		= $data->task_url.'/'.$task['project_id'];
					$bgs = array(1 => 'background-color:#B94A48;color:#fff;',2 => '',3 => 'background-color:#B94A48;color:#fff;');
					$values['from_priority']		= '<label style="border-radius: 5px;padding: 3px;white-space: nowrap;padding:0px 5px;'.$bgs[$old_task->task_priority].';">'.$task_priorities[$old_task->task_priority].'</label>';
					$values['to_priority']		= '<label style="border-radius: 5px;padding: 3px;white-space: nowrap;padding:0px 5px;'.$bgs[$task['task_priority']].';">'.$task_priorities[$task['task_priority']].'</label>';
	//				$values['to_status']		= $task_status[$task['task_status_id']]['name'];
					trigger_event($app_events[TP], $user_events[TP],$values,$exist_followers, $notify_data);
					$trigger_flag	= true;
				}

				// check task due date changed
				if (!empty($app_events[TD]) && !empty($user_events[TD]) && strtotime($old_task->finish_date)!=strtotime($task['finish_date']))
				{
					$values = $events['from_user'];
					$values['task_name'] = $task['name'];
					$values['finish_date'] 		= date('d M, Y', strtotime($task['finish_date']));
					$values['task_url'] 		= $data->task_url.'/'.$task['project_id'];
					trigger_event($app_events[TD], $user_events[TD],$values,$exist_followers, $notify_data);
					$trigger_flag	= true;
				}
			}

			// check task status changed
			if (!empty($app_events[TS]) && !empty($user_events[TS]) && $old_task->task_status_id!=$task['task_status_id'])
			{
				$values = $events['from_user'];
				$values['task_name'] = $task['name'];
				$values['due_date'] 		= $task['finish_date'];
				$values['modified_date'] 	= $task['last_updated_date'];
				$values['task_url'] 		= $data->task_url.'/'.$task['project_id'];
				$values['from_status']		= '<label style="white-space: nowrap;padding:0px 10px;border-radius: 5px;background-color:'.$task_status[$old_task->task_status_id]['bg_color'].';color:'.$task_status[$old_task->task_status_id]['text_color'].';">'.$task_status[$old_task->task_status_id]['name'].'</label>';
				$values['to_status']		= '<label style="white-space: nowrap;padding:0px 10px;border-radius: 5px;background-color:'.$task_status[$task['task_status_id']]['bg_color'].';color:'.$task_status[$task['task_status_id']]['text_color'].';">'.$task_status[$task['task_status_id']]['name'].'</label>';
				trigger_event($app_events[TS], $user_events[TS],$values,$exist_followers, $notify_data);
				$trigger_flag	= true;
			}

			if (!$trigger_flag)
			{
				trigger_event($app_events[TU], $user_events[TU],$values,$exist_followers, $notify_data);
			}
		}
	}
	
	function get_apps_user_list ($user_id, $entity_id, $user_ids= array())
	{
		global $CI;

		$query = $CI->db->query('SELECT * FROM ot_apps AS a JOIN ot_apps_entity AS ae ON ae.app_id=a.app_id WHERE ae.entity_id ='.$entity_id.' AND a.is_active =1 AND ae.is_enabled=1');
		$apps		= $query->result_array();

		if (!$apps)
		{
			return false;
		}
		// get users
		$sql = 'SELECT user_id,email from ot_entity_users WHERE entity_id='.$entity_id.' AND is_active=1';
		if ($user_ids)
		{
			$sql.=' AND user_id in ('.implode(',',$user_ids).')';
		}
		$query 		= $CI->db->query($sql);
		$users		= $query->result_array();

		if (!$users) return false;

		$tmp_users	= $users;
		$users		= array();
		foreach ($tmp_users as $user)
		{
			$users[$user['user_id']] = $user['email'];
		}
		$app_events = $user_events = array();
		foreach ($apps as $app)
		{
			$t_eve = JSON_decode($app['active_events']);
			if ($t_eve)
			{
				$query 			= $CI->db->query('SELECT * FROM ot_apps_webhooks WHERE app_id='.$app['app_id']);
				$app_eve_array	= $query->result_array();
				// split app events
				foreach ($app_eve_array as $row)
				{
					$row = array_merge($app,$row);
					$app_events[$row['event_code']][] = $row;
				}
				// overwrite user event with app event
				if (!$app['allow_user_event'])
				{
					foreach ($t_eve as $eve)
						$user_events[$eve][$app['app_id']] = $users;
				}
				else
				{
					// get users event related data
					$sql = 'SELECT aue.*,eu.email FROM ot_apps_user_event AS aue JOIN ot_entity_users AS eu on aue.user_id=eu.user_id WHERE eu.entity_id='.$entity_id.' AND eu.is_active=1 AND aue.app_id='.$app['app_id'];
					if ($user_ids)
					{
						$sql.=' AND eu.user_id in ('.implode(',',$user_ids).')';
					}
					$query 				= $CI->db->query($sql);
					$app_users_events	= $query->result_array();

					if ($app_users_events)
					{
						foreach ($app_users_events as $row)
						{
							// split event code
							$user_eve_code = explode(',',$row['event_codes']);
							if ($user_eve_code)
							{
								foreach ($user_eve_code as $eve)
								{
									$user_events[$eve][$app['app_id']][] = array('user_id' => $row['user_id'], 'email' => $row['email']);;
								}
							}
						}
					}
				}
			}
		}

		$query 		= $CI->db->query('SELECT concat(eu.first_name," ", eu.last_name) AS from_user, eu.email AS from_email FROM ot_entity_users AS eu WHERE eu.entity_id='.$entity_id.' AND eu.user_id='.$user_id);
		$from_user		= $query->row_array();
		return  array('app_events' => $app_events, 'user_events' => $user_events,'from_user'=>$from_user);
	}

	function trigger_event($apps, $users, $data, $followers, $notify_data)
	{
		foreach ($apps as $app)
		{
			// If thirdparty folder have file with app_name then include it & run that. 
			$file_name	= str_replace(" ", "_", strtolower($app['app_name']));
			$file	= FCPATH . APPPATH . 'third_party/addons/' . $file_name . '.php';
			if (file_exists($file))
			{
				include_once $file;
				if (class_exists($file_name))
				{
					$addon_obj	= new $file_name();
					if (method_exists($addon_obj, 'run'))
					{
						$addon_obj->run($app, $users, $data, $followers, $notify_data);
						continue;
					}
				}
			}

			$data['server_name'] = $app['server_name'];
			if (isset($users[$app['app_id']]))
			{
				$header = array($app['auth_key_name'] . ':' . $app['auth_key_value']);
				foreach ($users[$app['app_id']] as $user_id=>$to_email)
				{
					if (!in_array($user_id, $followers))
						continue;

					$data['to_email'] = $to_email;
					$pattern	= "/\{\{(.*?)\}\}/i";
					$data['content']	= urlencode(pattern_match($pattern, $app['content'] , $data));
					$pattern	= "/\{\{(.*?)\}\}/i";
					$call_back_url	= pattern_match($pattern, $app['call_back_url'] , $data);

					curl_post($call_back_url, array(), $header);
				}
			}
		}
	}

	function pattern_match ($pattern, $content, $data)
	{
		if (preg_match_all($pattern,$content,$matches) && !empty($matches[1]))
		{
			foreach($matches[1] as $key => $val)
			{
				$r_text = isset($data[$val])?$data[$val]:'';
				$content = str_replace($matches[0][$key],$r_text,$content);
			}
		}
		return $content;
	}

	function curl_post($url, $post = array(), $header = array())
	{
		//open connection
		$ch = curl_init();

		//set the url, number of POST vars, POST data
		curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch,CURLOPT_URL, $url);
		curl_setopt($ch,CURLOPT_POST, count($post));
		//curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8'));
		curl_setopt($ch,CURLOPT_POSTFIELDS, http_build_query($post));
		
		//execute post
		$result = curl_exec($ch);
		
		//close connection
		curl_close($ch);
	}
?>
