<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$is_ajax_request	= $this->input->is_ajax_request();

	if (!$is_ajax_request)
	{
		$this->load->view("header");
	}
?>
<div id="log-container">
	<div class="row">
		<span class="pull-left title"><?php echo lang('ACTIVITY LOG'); ?></span>
		<ul class="pull-right unstyled btns">
			<li class="rounded" data-bind="click:swap_view">
				<!-- ko if:is_day_view()==true -->
				<span class="week-icon"></span>
				<!-- /ko -->
			</li>
		</ul>
	</div>
	<div class="clearfix"></div>
	<div id="body-container" class="out-container no-right-cnt">
		<div id="alert_message" class="fix-it"></div>
		<div class="clearfix"></div>
		<div id="list-container">
			<div class="row day-view">
				<div class="clearfix"></div>
				<div class="widget">
					<div class="timeline">
						<span class="vline"></span>
						<div class="row tl-post">
						    <span class="time">01:30 PM</span>
							<span class="icon icon-attach"></span>
							<div>
							   <span>John Doe</span> attached an image to a blog post.
							</div>
						</div>
						<div class="row tl-post">
						    <span class="time">11:50 AM</span>
							<span class="icon icon-location"></span>
							<div>
							   <span>John Doe</span> added his location.
							</div>
						</div>
						<div class="row tl-post">
							<span class="icon icon-profile"></span>
						    <span class="time">09:40 AM</span>
							<div>
							   <span>John Doe</span> edited his profile.
							</div>
						</div>
						<div class="row tl-post">
							<span class="icon icon-message"></span>
						    <span class="time">10:30 AM</span>
							<div>
							   <span>John Doe</span> has sent you private message.
							</div>
						</div>
						<div class="row tl-post">
							<span class="icon icon-attach"></span>
						    <span class="time">05:30 PM</span>
							<div>
							   <span>John Doe</span> attached an image to a blog post.
							</div>
						</div>
						<div class="row tl-post">
							<span class="date_font label bg-green2 title">Apr 07,2013</span>
						</div>
					</div>
				</div>
<!--				<div class="row tl-post">
					<span class="label bg-green2 title">Contacts</span>
				</div>
				<br /><br />
				<div class="date">June 13</div>
				<div class="widget">
					<div class="timeline">
					</div>
				</div>-->
			</div>
		</div>
	</div>
</div>
<?php
	if (!$is_ajax_request)
	{
		$this->load->view("footer");
	}

	$jslang	= array();
?>
<script type="text/javascript">
	$(document).ready(function(){
		Otime.log.language	= <?php echo json_encode($jslang); ?>;
		Otime.log.projects	= <?php echo json_encode($projects); ?>;
		Otime.leave_days			= <?php echo json_encode($leave_date); ?>;
		window.Otime.load("log");
	});
</script>
