<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$budget_types	= $this->config->config['budget_type'];

	$class	= empty($class) ? '' : ' '.$class;
?>
<div id="budgetcontent" class="well npt npl npr container<?php echo $class; ?>" data-bind="with:budget,visible:($data.user_role()!='P' && $data.user_role()!='M')">
	<div class="container dib fw pr">
		<h4 class="pull-left"><?php echo lang('BUDGET'); ?></h4>
	<!-- ko if:parent().is_new_mode() == false -->
		<div class="pa transEdit" style="top:0;right:0;" data-bind="css:{vh:_info.is_edit_mode()==false}">
			<!-- ko if:_info.is_edit_mode()==true -->
			<a data-bind="click:save" id="save" class="pull-left" href="javascript:;"><?php echo lang('SAVE'); ?></a>
			<span class="separator pull-left">|</span>
			<a data-bind="click:cancel" id="cancel" class="cancel pull-left" href="javascript:;"><b>X</b></a>
			<!-- /ko -->
			<!-- ko if:_info.is_edit_mode()==false -->
			<div class="cp pull-left" data-bind="click:edit">
				<a href="javascript:;">
					<i class="icon-pencil">&nbsp;</i><?php echo lang('EDIT'); ?>
				</a>
			</div>
			<!-- /ko -->
		</div>
	<!-- /ko -->
	</div>
	<!-- ko ifnot:_info.is_edit_mode -->
	<div class="container dib fw"  data-bind="event:{dblclick:edit}">
		<div class="dib fw">
			<div class="pull-left" >
				<h6 data-bind="text:_info.budget_type_name"></h6>
				<!-- ko if:budget_alert_percent() >0 -->
					<span class="sub-title gray">
						<?php echo lang('ALERT_AT') . ' '; ?><!-- ko text:budget_alert_percent --><!-- /ko --><?php echo '% ' . lang('OF_BUDGET'); ?> (<span data-bind="html:_info.type_diplay" class=""></span>)
					</span>
				<!-- /ko -->
			</div>
			<div class="pull-right">
				<!-- ko ifnot:_info.isAmt -->
				<span class="h3" data-bind="hours:{val:_info.total_hours}"></span>&nbsp;Hrs
				<!-- /ko -->
				<!-- ko if:_info.isAmt -->
				<span class="h3" data-bind="currency:{val:_info.total_hours}"></span>
				<!-- /ko -->
			</div>
		</div>
		<div class="clearfix"></div>
		<hr class="nm">
		<div class="pull-left">
			<h6  data-bind="hidden:_info.isAmt"><?php echo lang('ACTUAL_HOURS'); ?></h6>
			<h6 data-bind="visible:_info.isAmt"><?php echo lang('ACTUAL_AMOUNT'); ?></h6>
		</div>
		<div class="pull-right">
			<!-- ko ifnot:_info.isAmt -->
			<span class="h3" data-bind="hours:{val:_info.actual_hours}, css:{'text-danger':_info.actual_hours()>_info.total_hours()}"></span>&nbsp;Hrs
			<!-- /ko -->
			<!-- ko if:_info.isAmt -->
			<span class="h3" data-bind="currency:{val:_info.actual_hours}, css:{'text-danger':_info.actual_hours()>_info.total_hours()}"></span>
			<!-- /ko -->
		</div>
	</div>
	<!-- /ko -->
	<!-- ko if:_info.is_edit_mode -->
	<div class="container">
		<div class="col-md-12 np form-group input-group">
			<span class="input-group-addon">
				<i><?php echo lang('BUDGET_TYPE'); ?></i>
			</span>
			<select class="form-control input-sm" data-bind="value:budget_type">
				<?php foreach ($budget_types as $key=>$val): ?>
				<option value="<?php echo $key; ?>"><?php echo $val; ?></option>
				<?php endforeach; ?>
			</select>
		</div>
		<div class="row nm">
			<!-- ko if:_info.isBGVal -->
			<div class="col-md-6 col-lg-12 npl form-group input-group">
				<span class="input-group-addon">
					<i><?php echo lang('BUDGET_VALUE'); ?></i>
				</span>
				<input type="text" maxlength="10" data-bind="value:budget_value, numberOnly:true" class="form-control input-small"/>
			</div>
			<!-- /ko -->
			<div class="col-md-12 col-lg-12 np form-group input-group">
				<span class="input-group-addon"><i><?php echo lang('ALERT_AT'); ?></i></span>
				<input type="text" data-bind="value:budget_alert_percent, numberOnly:true" maxlength="3" class="form-control" />
				<span class="input-group-addon alert_budget">% <?php echo lang('OF_BUDGET'); ?>(<span data-bind="html:_info.type_diplay" class=""></span>)</span>
			</div>
		</div>
	</div>
	<!-- /ko -->
</div>
<div class="clearfix"></div>
<div class="sep">&nbsp;</div>
<div class="sep">&nbsp;</div>
<div class="sep">&nbsp;</div>

