<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	set_cache_header();
?>
<div id="users-container" class="cutter-top">
	<div id="body-container" class="out-container no-right-cnt fh"  data-bind="css: {set_margin:is_list_view()==false && is_edit_mode()==false }">
		<div class="page-header-bar">
			<span class="title"><?php echo lang('USERS'); ?></span>
			<ul class="btns list-inline">
			<!-- ko ifnot:is_edit_mode -->
				<li class="img-circle icon40">
					<a href="javascript:;" title="<?php echo lang('ADD_NEW'); ?>" data-bind="click:addItem"><i class="icon-plus icon-metro img-circle"></i></a>
				</li>
				<li class="img-circle icon40">
					<a href="javascript:;" title="<?php echo lang('Swap View'); ?>" data-bind="click:swapView">
					<!-- ko if:is_list_view -->
						<i class="icon-th icon-metro img-circle"></i>
					<!-- /ko -->
					<!-- ko ifnot:is_list_view -->
						<i class="icon-list icon-metro img-circle"></i>
					<!-- /ko -->
					</a>
				</li>
			<!-- /ko -->
			<!-- ko if:is_edit_mode -->
				<li class="img-circle icon40">
					<a href="javascript:;" title="<?php echo lang('SAVE'); ?>" data-bind="click:save"><i class="icon-save icon-metro img-circle"></i></a>
				</li>
				<li class="img-circle icon40">
					<a href="javascript:;" title="<?php echo lang('CANCEL'); ?>" data-bind="click:cancel"><i class="icon-arrow-left icon-metro img-circle"></i></a>
				</li>
			<!-- /ko -->
			</ul>
		</div>
		<div id="alert_message" class="fix-it"></div>
		<div class="clearfix"></div>
		<div id="users-list-container" data-bind="hidden:is_edit_mode,css:{grid_height:is_list_view()==false}" class="container">
			<div class="alertMsg"></div>
			<div class="row" data-bind="visible:is_list_view">
				<div class="col-md-12" style="max-width: 1000px;">
					<table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-hover client-list-table vam" data-bind="visible:items().length>0">
						<thead>
							<tr>
								<th class="col-lg-6 ac"><?php echo lang('NAME'); ?></th>
								<th class="col-lg-3"><?php echo lang('ROLE'); ?></th>
								<th class="col-lg-2"><?php echo lang('RATE'); ?></th>
								<th class="col-lg-1"></th>
							</tr>
						</thead>
						<tbody data-bind="foreach:items">
							<tr class="cp">
								<td data-bind="event:{dblclick:$root.editItem}">
									<div class="row" >
										<div class="col-lg-12">
											<img class="img28x28" data-bind="img:user_image_path, attr:{title:first_name}" />
											<span style="padding-left:3px;" data-bind="title:{value:first_name() + ' ' + last_name(), length:25}"></span>
										</div>
									</div>
								</td>
								<td data-bind="click:$root.editItem" class="vam">
									<span data-bind="text:_info.role_display"></span>
								</td>
								<td class="vam">&#8377;<!-- ko text: hourly_rate --><!--/ko-->&nbsp;<?php echo lang('PER_HOUR'); ?></td>
								<td class="controls vam">
								<!-- ko if: _info.is_edit_permission()==true -->
									<div class="dropdown pull-right">
										<label class="dropdown-toggle" data-toggle="dropdown" data-bind="click:$root.get_info">&nbsp;&nbsp;&nbsp;&nbsp;<i class="icon-cog">&nbsp;</i></label>
										<ul class="dropdown-menu" data-bind="visible:is_active()==1">
											<li>
												<a href="javascript:;" data-bind="click:$parent.archiveItem(0)">
													<i class="icon-archive"></i>&nbsp;&nbsp;<?php echo lang('ARCHIVE'); ?>
												</a>
											</li>
											<li>
												<a href="javascript:;" data-bind="click:$parent.deleteItem, visible:_info.is_ts_posted()==false"">
													<i class="icon-trash"></i>&nbsp;&nbsp;<?php echo lang('DELETE'); ?>
												</a>
											</li>
											<li>
												<a href="javascript:;" data-bind="click:$parent.show_activity"><?php echo lang('USER_ACTIONS'); ?></a>
											</li>
											<li>
												<a href="javascript:;" data-bind="click:$parent.reset">
													<?php echo lang('RESET_PASSWORD'); ?>
												</a>
											</li>
										</ul>
										<ul class="dropdown-menu" data-bind="visible:is_active()==0">
											<li>
												<a href="javascript:;" data-bind="click:$parent.archiveItem(1)">
													<i class="icon-expand"></i>&nbsp;&nbsp;<?php echo lang('UNARCHIVE'); ?>
												</a>
											</li>
											<li>
												<a href="javascript:;" data-bind="click:$parent.deleteItem">
													<i class="icon-trash"></i>&nbsp;&nbsp;<?php echo lang('DELETE'); ?>
												</a>
											</li>
										</ul>
									</div>
									<label class="btn nm np edit btn-success pull-right" data-bind="click:$parent.editItem, visible:is_active() == 1">&nbsp;<?php echo lang('EDIT'); ?>&nbsp;</label>
								<!-- /ko -->
								</td>
							</tr>
						</tbody>
					</table>
					<div class="cutter-top text-center" data-bind="visible:items().length==0">
						<span class="well"><?php echo lang('NO_DATA_FOUND'); ?></span>
					</div>
				</div>
			</div>
		<div id="users-list" class="row" data-bind="hidden:is_list_view">
			<!-- ko foreach:items -->
			<div class="metro metro-item maso-item masonry-brick npt npl npr img-rounded" data-bind="css:Otime.setMetro()">
			<!-- ko if: _info.is_edit_permission() == true -->
			<div class="dropdown pull-right row client_button_group metro-edit" style="z-index:1">
				<a href="javascript:;" class="pull-left" data-bind="click:$root.editItem, visible:is_active()==1" id="edit"><i class="icon-pencil icon-white">&nbsp;</i>&nbsp;&nbsp;<?php echo lang('EDIT'); ?></a>
				<span class="separator pull-left" data-bind="visible:is_active()==1">|</span>
				<div class="pull-left">
					<a href="javascript:;" class="dropdown-toggle" data-toggle="dropdown" data-bind="click:$root.get_info" id="options"><i class="icon-cog icon-white">&nbsp;</i></a>
					<ul class="dropdown-menu" data-bind="visible:is_active()==1">
						<li>
							<a href="javascript:;" data-bind="click:$parent.archiveItem(0)">
								<i class="icon-archive"></i>&nbsp;&nbsp;<?php echo lang('ARCHIVE'); ?>
							</a>
						</li>
						<li>
							<a href="javascript:;" id="delete" data-bind="click:$parent.deleteItem, visible:_info.is_ts_posted()==false">
								<i class="icon-trash"></i>&nbsp;&nbsp;<?php echo lang('DELETE'); ?>
							</a>
						</li>
						<li>
							<a href="javascript:;" id="user_active" data-bind="click:$parent.show_activity"><?php echo lang('USER_ACTIONS'); ?></a></li>
						<?php if (is_admin($role)): ?>
							<li><a href="javascript:;" data-bind="click:$parent.reset"><?php echo lang('RESET_PASSWORD'); ?></a></li>
						<?php endif; ?>
					</ul>
					<ul class="dropdown-menu" data-bind="visible:is_active()==0">
						<li>
							<a href="javascript:;" data-bind="click:$parent.archiveItem(1)">
								<i class="icon-expand"></i>&nbsp;&nbsp;<?php echo lang('UNARCHIVE'); ?>
							</a>
						</li>
						<li>
							<a href="javascript:;" id="delete" data-bind="click:$parent.deleteItem, visible:_info.is_ts_posted()==false">
								<i class="icon-trash"></i>&nbsp;&nbsp;<?php echo lang('DELETE'); ?>
							</a>
						</li>
					</ul>
				</div>
			</div>
			<!-- /ko -->
			<span class="pull-left">
				<img class="thumb-img" fnt-size="35px" data-bind="img:user_image_path, attr:{title:first_name}" />
			</span>
			<div class="metro_content content dib pull-left" style="max-width:60%;" data-bind="event:{dblclick:$parent.editItem}">
				<h4>
					<b data-bind="title:{value:first_name() + ' ' + last_name(), length:22}" class="nmb"></b>
				</h4>
				<span class="pull-left align-left role_display" data-bind="text:_info.role_display"></span>
				<div class="clearfix"></div>
			</div>
			<!-- ko if: hourly_rate()!=0 -->
			<div class="tran pull-right nmt pa right">
				<h5 class="side-bar-text nmt"><?php echo CURRENCY;?><!-- ko text:hourly_rate --><!--/ko--><?php echo lang('PER_HOUR'); ?></h5>
			</div>
			<!-- /ko -->
			</div>
			<!-- /ko -->
			<div class="cp metro metro-item maso-item masonry-brick npt npl npr img-rounded metro-new add" data-bind="click:addItem, hidden:active()==0" id="add_user"></div>
			<div class="metro metro-item maso-item masonry-brick img-rounded text-center" data-bind="hidden:$root.is_edit_mode">
				<ul class="row" style="list-style:none;padding-top:20px;">
					<li>
						<a href="javascript:;" data-bind="hidden:finish, click:load_more" class="well"><?php echo lang('SHOW_MORE'); ?></a>
						<a href="javascript:;" class="well" data-bind="visible:$root.show_loading"><?php echo lang('LOADING'); ?></a>
					</li>
				</ul>
			</div>			
			<div class="clearfix"></div>
			</div>
		</div>	
		<!--<div class="pagination col-lg-12 text-center" data-bind="hidden:is_edit_mode">
			<ul class="row" style="list-style:none;">
				<li>
					<a href="javascript:;" data-bind="hidden:finish, click:load_more" class="well"><?php echo lang('SHOW_MORE'); ?></a>
					<a href="javascript:;" class="well" data-bind="visible:show_loading"><?php echo lang('LOADING'); ?></a>
				</li>
			</ul>
		</div>-->
		<div id="users-edit-container" data-bind="visible:is_edit_mode">
			<div id="edit_layout">
			</div>
		</div>
		<div id="comment_layout" class="page-slide fh col-lg-5 col-md-5" style="top:90px;" data-bind="with:ActivityHandler, visible:is_comment_mode">
			<?php $this->load->view('comments/timeline', array('module'=>'activity', 'type'=>'users')); ?>
		</div>
	</div>
	<div data-bind="hidden:is_edit_mode">
        <a id="active_box" class="user_box cp" data-bind="visible:active()==0 && active_count()>0">
            <div data-bind="click: function(){ refresh('1') }"><?php echo lang('ACTIVE_USERS'); ?>:&nbsp;<!-- ko text:active_count --><!-- /ko --></div>
        </a> 
        <a id="archive_box" class="user_box cp" data-bind="visible:active()==1 && archive_count()>0">
            <div data-bind="click: function(){ refresh('0') }"><?php echo lang('ARCHIVED_USERS'); ?>:&nbsp;<!-- ko text:archive_count --><!-- /ko --></div>
        </a>
    </div>
</div>
<?php
	$jslang	= array();
	$tmp	= array('SUCCESS_SAVE', 'INVALID_EMAIL', 'ARCHIVE_USER', 'UNARCHIVE_USER','CONFIRM_DELETE_USER','ERR_PRIMARY_DATA_MISSING','CONFIRM_RESET_PASSWORD', 
					'ARCHIVED_USERS', 'ACTIVE_USERS','DELETE_USER_CONFIRM_MSG', 'ARCHIVE_USER_CONFIRM_MSG', 'UNARCHIVE_USER_CONFIRM_MSG');
	foreach ($tmp as $val)
	{
		$jslang[$val]	= lang($val);
	}

	$jslang['FIRST_NAME_REQUIRED']	= lang('FIELD_REQUIRED', lang('FIRST_NAME'));
	$jslang['SELECT_USER_ROLE']		= lang('FIELD_REQUIRED', lang('USER_ROLE'));
	$jslang['DEPARTMENT_REQUIRED']	= lang('FIELD_REQUIRED', lang('DEPARTMENT'));
	$jslang['HOURLY_RATE_REQUIRED']	= lang('FIELD_REQUIRED', lang('HOURLY_RATE'));

?>
<script type="text/javascript">
	$(document).ready(function(){
		Otime.Users.user_roles	= <?php echo json_encode($user_role); ?>;
		Otime.Users.language	= <?php echo json_encode($jslang); ?>;
	});
</script>
